window.C8994 = function(sdk,callback,callbackObj) {
    this.name = "ddw";
    window.rdsdkinfo = sdk;
    window.getUserInfoCallback = null;
    window.rechargeCallback = null;
    window.userId = null;
    window.roleId = null;
    window.roleLevel = null;
    window.isCreate = false;
    this.init = function(){
        if(sdk.readyCallback && sdk.readyCallbackObj){
            sdk.readyCallback.call(sdk.readyCallbackObj);
        }
    }

    this.getUserInfo = function(callback){
        window.location.href='dr://getUserInfo:123';
        window.getUserInfoCallback = callback;
        // AndroidJs.login();
    }

    this.recharge = function(input,callback){
        // console.info('input',input);
        // console.info('price',input.price/100);
        // console.info('open_id',input.open_id);
        // console.info('rd_order_no',input.rd_order_no);
        // AndroidJs.recharge(input.price/100,input.open_id,input.rd_order_no);
        console.info('测试支付商品id: rygjios6');
        window.location.href='dr://buyGameProps:rygjios6_rygjios6';
    }

    this.reportRoleCreate = function(){
        window.isCreate = true;  
    }

    this.reportRoleInformation = function(info,callback){
        if(info[0]){
            var userInfo = info[0];
            //创角上报
            if(window.isCreate){
                console.info('上报创角数据');
                window.isCreate = null;
                sendRoleData(userInfo);
                return;
            }

            //登录上报
            if(!window.roleId && !window.roleLevel){
                console.info('上报登录数据');
                sendRoleData(userInfo);
            }
            if(!window.roleId){
                window.roleId = userInfo.role_id;
            }
            if(!window.roleLevel){
                window.roleLevel = userInfo.role_level;
            }
            if(window.roleId == userInfo.role_id){
                //升级上报
                if(userInfo.role_level > window.roleLevel){
                    console.info('上报升级数据');
                    window.roleLevel = userInfo.role_level;
                    sendRoleData(userInfo);
                    return;
                }
            }else{
                //切换角色
                console.info('上报登录数据');
                window.roleId = userInfo.role_id;
                window.roleLevel = userInfo.role_level;
                sendRoleData(userInfo);
            }
        }
    }

    function sendRoleData(userInfo){
        var param = {
            app_id:sdk.app_id,
            game_id:sdk.game_id,
            channel_id:sdk.channel_id,
            uid:window.userId,
            server_id:userInfo.server_id,
            server_name:userInfo.server_name,
            role_id:userInfo.role_id,
            role_name:userInfo.role_name,
            role_level:userInfo.role_level,
            role_vip:userInfo.role_vip
        };
        var p = JSON.stringify(param);
        var url= sdk.baseUrl + "/index.php/user/api/reportUserRole/";
        var data = JSON.stringify({'data':'{"mod":"user","do":"api.reportUserRole","p":'+p+'}',"h":""});
        sdk.send(url,data,(result)=>{
            console.log('reportRoleInformation...',result);
        },sdk) 
    }

}

function getIPAInfo(content){
    console.info('支付结果1',content);
    var sdk = window.rdsdkinfo;
    var param = {
        content:content,
        sand:sdk.app_info.ddw.SAND || 0
    };
    var p = JSON.stringify(param);
    var url= sdk.baseUrl + "/index.php/pay/ddw/payData/";
    var data = JSON.stringify({'data':'{"mod":"pay","do":"ddw.payData","p":'+p+'}',"h":""});
    sdk.send(url,data,(result)=>{
        console.log('reportRoleInformation...',result);
    },sdk) 
}

function rechargeJSCallBack(reset){
    console.info('支付结果2',reset);
}

function getUserInfoOCCallback(obj){
    console.info("obj",obj);
    var sdk = window.rdsdkinfo;
    var param = {
        login_type:obj.login_type || 0,
        login_uuid:obj.login_uuid || '',
        extra:obj.extra
    };
    var p = JSON.stringify(param);
    var url= sdk.baseUrl + "/index.php/pay/ddw/checkUser/";
    var data = JSON.stringify({'data':'{"mod":"pay","do":"ddw.checkUser","p":'+p+'}',"h":""});
    sdk.send(url,data,function(res){
        res = JSON.parse(res);
        if(res.errCode == 0){
            var result = [];
            window.userId = res.data;
            result.open_id = res.data;
            result.password = '';
            result.name =  '';
            result.avatar = "";
            window.getUserInfoCallback(result);
        }else{
            console.info("登录失败",res.error);
        }
    },sdk)
}

function requestVisitorsAccount(vopen_id){
        var param = {
            open_id:vopen_id    
        };
        var p = JSON.stringify(param);
        var url= sdk.baseUrl + "/index.php/pay/ddw/checkVUser/";
        var data = JSON.stringify({'data':'{"mod":"pay","do":"ddw.checkVUser","p":'+p+'}',"h":""});
        sdk.send(url,data,function(res){
            res = JSON.parse(res);
            if(res.errCode == 0){
                var dd = JSON.parse(res.data);
                if(dd.id){
                    var result = [];
                    window.userId = dd.id;
                    result.open_id = dd.id;
                    result.password = '';
                    result.name =  '';
                    result.avatar = "";
                    window.getUserInfoCallback(result);
                    if(vopen_id == '-1'){
                        window.location.href='dr://saveVisitorsAccount:' + dd.open_id;
                    }
                }
            }else{
                console.info("游客登录失败",res.error);
            }
        },sdk)
}

function loginResponse(info){
    delCookie('account');
    delCookie('password');
    console.info('info',info);
    var info = JSON.parse(info);
    var sdk = window.rdsdkinfo;
    var param = {
        userId:info.userId,
        sessionKey:info.sessionKey,
        gid:sdk.app_info.ddw.GID,
        app_key:sdk.app_info.ddw.SECRET_KEY,
    };
    var p = JSON.stringify(param);
    var url= sdk.baseUrl + "/index.php/pay/ddw/checkUserSign/";
    var data = JSON.stringify({'data':'{"mod":"pay","do":"ddw.checkUserSign","p":'+p+'}',"h":""});
                
    sdk.send(url,data,function(result){
        result = JSON.parse(result);
        if(result.errCode == 0){
            if (result.data == 0) {
                var result = [];
                result.open_id = info.userId;
                result.password = '';
                result.name =  '';
                result.avatar = "";
                window.getUserInfoCallback(result);
            }else {
                console.info("验签失败或链接失效");
            }
        }else{
            console.info("请求后台接口失败");
        }

    },sdk)
}

function objArgs(url,obj) {
    var url = url + '?'; // 提前加好问号
    for(var name in obj){
        url += name + '=' + encodeURIComponent(obj[name]) + '&'; // 转码并进行赋值
    }
    url = url.substring(0,url.length-1); // 去掉最后一个&符号
    return url; // 返回
}

function close_iframepay(){
    var iframe = document.getElementById("iframepay");
    var closeBtn = document.getElementById("close_iframepay");
    document.body.removeChild(iframe);
    document.body.removeChild(closeBtn);
}

