function osType(){
    var ua = navigator.userAgent,
    isWindowsPhone = /(?:Windows Phone)/.test(ua),
    isSymbian = /(?:SymbianOS)/.test(ua) || isWindowsPhone,
    isAndroid = /(?:Android)/.test(ua),
    isFireFox = /(?:Firefox)/.test(ua),
    isChrome = /(?:Chrome|CriOS)/.test(ua),
    isTablet = /(?:iPad|PlayBook)/.test(ua) || (isAndroid && !/(?:Mobile)/.test(ua)) || (isFireFox && /(?:Tablet)/.test(ua)),
    isPhone = /(?:iPhone)/.test(ua) && !isTablet,
    isPc = !isPhone && !isAndroid && !isSymbian;
    return isPc;
};

function getPayType(channelObj,price,osType){
    if(osType && channelObj && channelObj.RDPAY){
        price = price || 0;
        var ary = channelObj.RDPAY;
        if(Array.isArray(ary)){
            var regPos = /^\d+(\.\d+)?$/; //非负浮点数
            var regNeg = /^(-(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*)))$/; //负浮点数
            var flag = null;
            var u = navigator.userAgent, app = navigator.appVersion;
            var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; //g
            var isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
            if(isAndroid){
                flag = true
            }
            if(isIOS){
        　　　　 flag = false;
            }
            for (var i = 0; i < ary.length; i++) {
                var key = ary[i];
                if(key == "n"){
                    return true;
                }
                if(key == "an"){
                    if(flag === true) return true;
                }
                if(key == "ios"){
                    if(flag === false) return true;
                }
                if(regPos.test(key) || regNeg.test(key)){
                    if(key != 0 && key > (price/100)) return true;
                }
                if(Array.isArray(key)){
                    if(window.returnCitySN){
                        for (var n = key.length - 1; n >= 0; n--) {
                            if(key[n] != "" && window.returnCitySN.indexOf(key[n]) != -1){
                                return true;
                            }
                        }
                    }   
                }

            }
            return false;
        }   
    }
    return true;
}