class RDSDK{
    constructor(callback,callbackObj){
        var param = this.getParam("debug");

        if(param == "true"){
            console.info("param debug:"+param);
            this.baseUrl = "//www.d.com/"; 
        }elseif(param == 'app'){
            this.baseUrl = "./";
            // this.baseUrl = "//center-test.rd-game.com/";
        }else{
        	this.baseUrl = "//center.rd-game.com/";
        }

        var area = this.getParam("area");
        if(area == "japan"){ 
            this.baseUrl = "//center-japan.rd-game.com/"; 
        }

        this.pay_type = "select";
        this.readyCallback = null;
        this.readyCallbackObj = null;
        this.app_id = null;
        this.channel_id = null;
        this.game_id = null;
        this.game_login_url = null;
        this.app_info = null;

        this.userInfoCallBack = null;
        this.rechargeCallBack = null;
        this.signkey = null;
        this.RDPAYS = null;
        this.RDPAYSRES = null;
        this.RDPAYSOS = true;
        this.wddownBox = false;
        this.wdConfigs = null;
        var channel_id = parseInt(this.getParam("channel_id"));
        this.ready(callback,callbackObj);
        this.init(channel_id);
        //反射后的渠道实例
        this.channelInst = null;

        //加载支付Css
        MiniSite.CssLoader.load(this.baseUrl+"sdk/payBox.css");
        MiniSite.CssLoader.load(this.baseUrl+"sdk/weui.min.css");
        MiniSite.JsLoader.load(this.baseUrl+"sdk/crypto-js/crypto-js.js");
        MiniSite.JsLoader.load(this.baseUrl+"sdk/zepto.min.js");
        MiniSite.JsLoader.load(this.baseUrl+"sdk/js/rdpays.js");

        // 需要vConsole时打开以下s代码
        // MiniSite.JsLoader.load(this.baseUrl+"sdk/jquery.min.js");
        // MiniSite.JsLoader.load(this.baseUrl+"sdk/jquery.cookie.js");
        // MiniSite.JsLoader.load(this.baseUrl+"sdk/zepto.touch.min.js");
        // MiniSite.JsLoader.load(this.baseUrl+"sdk/vconsole.min.js",()=>{
        //      // 初始化vConsole
        //     window.vConsole = new window.VConsole({
        //     defaultPlugins: ['system', 'network', 'element', 'storage'], // 可以在此设定要默认加载的面板
        //     maxLogNumber: 1000,
        //     // disableLogScrolling: true,
        //     onReady: function() {
        //         console.log('vConsole is ready.');
        //     },
        //     onClearLog: function() {
        //         console.log('on clearLog');
        //     }
        //     });
        // },this);

        // window.addEventListener('message', function(event) {
        //     var result = event.data;
        //     if (result.success){
        //         console.log('message:',result.pay_url);
        //         window.top.location.href = result.pay_url;
        //     }
        // });
    }

    isDebug(){
        var param = this.getParam("debug");
        return param === "true"?true:false;
    }

    getParam(paramName) {
        var paramValue = "", isFound = !1;
        if (window.location.search.indexOf("?") == 0 &&window.location.search.indexOf("=") > 1) {
            var arrSource = unescape(window.location.search).substring(1, window.location.search.length).split("&"), i = 0;
            while (i < arrSource.length && !isFound) arrSource[i].indexOf("=") > 0 && arrSource[i].split("=")[0].toLowerCase() == paramName.toLowerCase() && (paramValue = arrSource[i].split("=")[1], isFound = !0), i++
        }
        return paramValue == "" && (paramValue = null),paramValue;
    }

    /**
     * 初始化
     * @param channel_id 渠道ID
     */
    init(channel_id = 2001){
        this.channel_id = channel_id;
        window.baseUrl = this.baseUrl;
        MiniSite.JsLoader.load(this.baseUrl+"sdk/channel/C"+this.channel_id+".js",function(){
            this.channelInst = new window['C'+this.channel_id](this);
            console.log("init with "+this.channelInst.name);
            this.channelInst.init();
        },this);
    }

    /**
     * 准备完成后触发
     */
    ready(callback,callbackObj){
        this.readyCallback = callback;
        this.readyCallbackObj = callbackObj;
    }

    /**
     * 获取用户信息
     * @param {Object} config 相关设置.
     * @param {Function} cb   获取成功后的回调
     */
    getUserInfo(config,cb){
        var config = wdConfigs(config,this.wdConfigs);
        this.userInfoCallBack = cb;
        // 获取APP信息
        console.info("正在验证APP信息...");

        var url= this.baseUrl + "/index.php/user/api/APPIDInfo/";
        var p = JSON.stringify(config);
        var data=JSON.stringify({'data':'{"mod":"user","do":"api.APPIDInfo","p":'+p+'}',"h":""});

        this.send(url,data,function(result){
            result = JSON.parse(result);
            if(result.errCode == 0){
                console.info("验证成功!APP_DATA:");
                console.info(result);
                this.app_id = result.data.id;
                this.game_id = result.data.game_id;
                this.signkey = result.data.signkey;
                this.game_login_url = result.data.loginUrl;
                this.app_info = JSON.parse(result.data.info);

                this.reportPV();
                this._channelUserInfo(config);
                this._tryOpenConsole(this.app_info);
            }else{
                console.error(result.error);
            }
        },this)
    }

    /**
     * 用户充值
     * @param {Object} config 相关设置.
     * @param {Function} cb   获取成功后的回调
     */
    recharge(config,cb){
        var config = wdConfigs(config,this.wdConfigs);
        this.rechargeCallBack = cb;
        this.pay_type = config.pay_type;
        // 获取APP信息
        console.info("正在验证APP信息...");

        var url= this.baseUrl + "/index.php/user/api/APPIDInfo/";
        var p = JSON.stringify(config);
        var data=JSON.stringify({'data':'{"mod":"user","do":"api.APPIDInfo","p":'+p+'}',"h":""});
        this.send(url,data,function(result){
            result = JSON.parse(result);
            if(result.errCode == 0){
                console.info("验证成功!APP_DATA:");
                console.info(result);
                this.app_id = result.data.id;
                this.game_id = result.data.game_id;
                this.game_login_url = result.data.loginUrl;
                this.signkey = result.data.signkey;
                this.app_info = JSON.parse(result.data.info);
                this._createOrder(config);
            }else{
                console.error(result.error);
            }
        },this)
    }

    /**
     * 渠道分享判断
     * 本渠道是否支持分享 支持返回true,不支持返回false
     */
    hasSharingMethod(callback){
        // 获取channel表share信息
        console.info("正在验证是否支持分享...");

        var url= this.baseUrl + "/index.php/channel/api/ChannelShare/";
        var p = JSON.stringify({channel_id:this.channel_id});
        var data=JSON.stringify({'data':'{"mod":"channel","do":"api.ChannelShare","p":'+p+'}',"h":""});
        this.send(url,data,function(result){
            result = JSON.parse(result);
            if(result.errCode == 0){
                callback(result.data == 1?true:false);
            }else{
                alert(result.error);
            }
        },this)
    }


    /**
     * 用户分享
     */
    share(config,callback){
        console.log("channel_inst do share...");
        this.channelInst.share(config,function(res)  {
            console.info("share.res..",res);
        });
    }

    /**
     * 本渠道是否支持关注 支持返回true,不支持返回false
     */
    hasInterestMethod(callback){
        // 获取channel表interest信息
        console.info("正在验证是否支持关注...");

        var url= this.baseUrl + "/index.php/channel/api/ChannelInterest/";
        var p = JSON.stringify({channel_id:this.channel_id});
        var data=JSON.stringify({'data':'{"mod":"channel","do":"api.ChannelInterest","p":'+p+'}',"h":""});
        this.send(url,data,function(result){
            result = JSON.parse(result);
            if(result.errCode == 0){
                callback(result.data == 1?true:false);
            }else{
                alert(result.error);
            }
        },this)
    }

    /**
     * 检测用户是否关注公众号 是返回true,否返回false
     */
    hasInterested(config,callback){
        // 获取channel表interest信息
        console.info("检测用户是否关注公众号...");
        this.channelInst.hasInterested(config,function(res)  {
            console.info("hasinterest.res..",res);
            callback(res);
        });

    }


    /**
     * 用户关注
     */
    interest(){
        console.log("channel_inst do interest...");
        this.channelInst.interest();
    }

    /**
     * 激活数据上报
     */
    reportPV(){
        var url= this.baseUrl + "/index.php/user/api/report/";
        var param = {
            "APPID":this.app_id
            ,"channel_id":this.channel_id
            ,"key":"pv"
        };
        var p = JSON.stringify(param);
        var data = JSON.stringify({'data':'{"mod":"user","do":"api.report","p":'+p+'}',"h":""});

        this.send(url,data,function(result){
            console.log("report ok");
        },this)

        console.info("接收激活...");
        try {
            if(typeof this.channelInst.reportPV === "function") { //是函数    其中 FunName 为函数名称
                this.channelInst.reportPV();
            }
        } catch(e) {}

    }

    /**
     * 创角数据上报
     */
    reportRoleCreate(){
        var url= this.baseUrl + "/index.php/user/api/report/";
        var param = {
            "APPID":this.app_id
            ,"channel_id":this.channel_id
            ,"key":"roleCreate"
        };
        var p = JSON.stringify(param);
        var data = JSON.stringify({'data':'{"mod":"user","do":"api.report","p":'+p+'}',"h":""});

        this.send(url,data,function(result){
            console.log("report ok");
        },this)

        console.info("接收创角...");
        try {
            if(typeof this.channelInst.reportRoleCreate === "function") { //是函数    其中 FunName 为函数名称
                this.channelInst.reportRoleCreate();
            }
        } catch(e) {}


    }

    /**
     * 活跃数据上报
     */
    reportRoleActive(){
        var url= this.baseUrl + "/index.php/user/api/report/";
        var param = {
            "APPID":this.app_id
            ,"channel_id":this.channel_id
            ,"key":"roleActive"
        };
        var p = JSON.stringify(param);
        var data = JSON.stringify({'data':'{"mod":"user","do":"api.report","p":'+p+'}',"h":""});

        this.send(url,data,function(result){
            console.log("report ok");
        },this)
        console.info("接收活跃...");
        try {
            if(typeof this.channelInst.reportRoleActive === "function") { //是函数    其中 FunName 为函数名称
                this.channelInst.reportRoleActive();
            }
        } catch(e) {}

    }

    /**
     * 接收角色上报
     */
    reportRoleInformation(config,callback){
        console.info("角色上报...");
        try {
            if(typeof this.channelInst.reportRoleInformation === "function") { //是函数    其中 FunName 为函数名称
                this.channelInst.reportRoleInformation(config,function(res)  {
                    console.info("reportRoleInformation.res..",res);
                    callback(res);
                });
            }
        } catch(e) {}
    }

    /**
     * 完成新手引导
     */
    completeNoviceGuide(){
        try {
            if(typeof this.channelInst.completeNoviceGuide === "function") {
                this.channelInst.completeNoviceGuide();
            }
        } catch(e) {}
    }

    /**
     * 首次充值
     */
    firstRecharge(){
        try {
            if(typeof this.channelInst.firstRecharge === "function") {
                this.channelInst.firstRecharge();
            }
        } catch(e) {}
    }

    /**
     * 首次登录
     */
    firstLogin(){
        try {
            if(typeof this.channelInst.firstLogin === "function") {
                this.channelInst.firstLogin();
            }
        } catch(e) {}
    }

    /**
     * 播放广告
     */
    broadcastAd(config,callback){
        this.channelInst.broadcastAd(config,function(res)  {
            console.info("broadcastAd.res..",res);
            callback(res);
        });
    }

    /**
     * 打开VConsole
     * @param {Object} app_info
     */
    _tryOpenConsole(app_info){
        // console.log("app_info",app_info);
        var vConsoleObj = app_info.vConsole;
        console.log("vConsoleObj",vConsoleObj);
        if(!vConsoleObj)return;
        var isOpen = vConsoleObj.open == true?true:false;
        var channel_ids = vConsoleObj.channel_ids;
        if(!isOpen || !channel_ids)return;
        if(isOpen){
            if(channel_ids.indexOf(this.channel_id) >= 0){
                MiniSite.JsLoader.load(this.baseUrl+"sdk/jquery.min.js");
                MiniSite.JsLoader.load(this.baseUrl+"sdk/jquery.cookie.js");
                MiniSite.JsLoader.load(this.baseUrl+"sdk/zepto.touch.min.js");
                MiniSite.JsLoader.load(this.baseUrl+"sdk/vconsole.min.js",function(){
                    // 初始化vConsole
                    window.vConsole = new window.VConsole({
                        defaultPlugins: ['system', 'network', 'element', 'storage'], // 可以在此设定要默认加载的面板
                        maxLogNumber: 1000,
                        // disableLogScrolling: true,
                        onReady: function() {
                            console.log('vConsole is ready.');
                        },
                        onClearLog: function() {
                            console.log('on clearLog');
                        }
                    });
                },this);
            }
        }
    }

    /**
     * 创建订单
     */
    _createOrder(config){
        //////////鉴权//////////////////////////////////////////////////////////////////////////////////////////
        var authUrl = this.baseUrl + "/index.php/user/api/AuthEntication/";
        var paramUrl = {
            channel_id:this.channel_id,
            game_id:this.app_id
        };
        var pUrl = JSON.stringify(paramUrl);
        var dataUrl=JSON.stringify({'data':'{"mod":"user","do":"api.AuthEntication","p":'+pUrl+'}',"h":""});
        this.send(authUrl,dataUrl,function(results){
            var auth = JSON.parse(results);
            ////////////////////////////////////
            if(auth.data == 0){
                var url= this.baseUrl + "/index.php/pay/order/create/";
                var param = {
                    APPID:this.app_id,
                    uuid:config.uuid,
                    pay_type:this.pay_type,
                    cp_out_order_no:config.out_order_no,
                    channel_id:this.channel_id,
                    price:config.price
                };
                console.info("正在创建订单... param:",this.RDPAYS);
                var paymod = this.getParam('paymod');

                if(this.RDPAYS){
                    var userUrl= this.baseUrl + "/index.php/user/api/getUserPosition/";
                    var uP = JSON.stringify(param);
                    var datas = JSON.stringify({'data':'{"mod":"user","do":"api.getUserPosition","p":'+uP+'}',"h":""});
                    this.send(userUrl,datas,function(result){
                        result = JSON.parse(result);
                        if(result.errCode == 0 && result.data.city){
                            window.returnCitySN = result.data.province + result.data.city;
                        }
                        this.RDPAYSRES = getPayType(this.RDPAYS,config.price,this.RDPAYSOS);
                        if(!this.RDPAYSRES && paymod){
                            paymod = null;
                        }
                        console.log("paymod1:",paymod);
                        if (paymod) {
                            var judge = paymod.search("none");
                            if (paymod.search("none") == -1) {
                                judge = 0;
                            } else {
                                judge = 1;
                            }
                        } else {
                            var judge = 0;
                        }

                        console.log("judge:",judge);
                        if(this.pay_type == "select" && !judge){
                            console.info("this.pay_type：",this.pay_type);
                            MiniSite.loadPayBox(config.price,function(type){
                                this.pay_type = type;
                                param.pay_type = this.pay_type;
                                console.info("订单参数:"+JSON.stringify(param));

                                console.log(param);
                                var signature = this.signHashHmac(param,atob(this.signkey));
                                param.sign = signature;

                                var p = JSON.stringify(param);
                                var data = JSON.stringify({'data':'{"mod":"pay","do":"order.create","p":'+p+'}',"h":""});
                                this.send(url,data,function(result){
                                    result = JSON.parse(result,true);
                                    if(result.errCode == 0){
                                        console.info("订单创建成功!order_data:");
                                        console.info(result.data);
                                        config['rd_order_no'] = result.data['order'].rd_order_no;
                                        config['state'] = result.data['order'].state;
                                        config['open_id'] = result.data['user'].username.split("gameid")[0];
                                        console.info(config);
                                        this._channelRecharge(config);
                                    }else{
                                        console.error(result.error);
                                    }
                                },this)
                            },this);
                        }else{
                            console.info("订单参数:"+JSON.stringify(param));

                            var signature = this.signHashHmac(param,atob(this.signkey));
                            param.sign = signature;
                            console.log(param);
                            var p = JSON.stringify(param);
                            var data = JSON.stringify({'data':'{"mod":"pay","do":"order.create","p":'+p+'}',"h":""});
                            this.send(url,data,function(result){
                                result = JSON.parse(result);
                                if(result.errCode == 0){
                                    console.info("订单创建成功!order_data:");
                                    console.info(result);
                                    config['rd_order_no'] = result.data['order'].rd_order_no;//燃点的订单号
                                    config['open_id'] = result.data['user'].username.split("gameid")[0];//燃点用户的openid
                                    config['state'] = result.data['order'].state;//燃点订单的状态
                                    console.info(config);
                                    this._channelRecharge(config);
                                }else{
                                    console.error(result.error);
                                }
                            },this)
                        }

                    },this);
                }else{

                    console.log("paymod2:",paymod);
                    if (paymod) {
                        var judge = paymod.search("none");
                        if (paymod.search("none") == -1) {
                            judge = 0;
                        } else {
                            judge = 1;
                        }
                    } else {
                        var judge = 0;
                    }

                    console.log("judge:",judge);
                    if(this.pay_type == "select" && !judge){
                        console.info("this.pay_type：",this.pay_type);
                        MiniSite.loadPayBox(config.price,function(type){
                            this.pay_type = type;
                            param.pay_type = this.pay_type;
                            console.info("订单参数:"+JSON.stringify(param));

                            console.log(param);
                            var signature = this.signHashHmac(param,atob(this.signkey));
                            param.sign = signature;

                            var p = JSON.stringify(param);
                            var data = JSON.stringify({'data':'{"mod":"pay","do":"order.create","p":'+p+'}',"h":""});
                            this.send(url,data,function(result){
                                result = JSON.parse(result,true);
                                if(result.errCode == 0){
                                    console.info("订单创建成功!order_data:");
                                    console.info(result.data);
                                    config['rd_order_no'] = result.data['order'].rd_order_no;
                                    config['state'] = result.data['order'].state;
                                    config['open_id'] = result.data['user'].username.split("gameid")[0];
                                    console.info(config);
                                    this._channelRecharge(config);
                                }else{
                                    console.error(result.error);
                                }
                            },this)
                        },this);
                    }else{
                        console.info("订单参数:"+JSON.stringify(param));

                        var signature = this.signHashHmac(param,atob(this.signkey));
                        param.sign = signature;
                        console.log(param);
                        var p = JSON.stringify(param);
                        var data = JSON.stringify({'data':'{"mod":"pay","do":"order.create","p":'+p+'}',"h":""});
                        this.send(url,data,function(result){
                            result = JSON.parse(result);
                            if(result.errCode == 0){
                                console.info("订单创建成功!order_data:");
                                console.info(result);
                                config['rd_order_no'] = result.data['order'].rd_order_no;//燃点的订单号
                                config['open_id'] = result.data['user'].username.split("gameid")[0];//燃点用户的openid
                                config['state'] = result.data['order'].state;//燃点订单的状态
                                console.info(config);
                                this._channelRecharge(config);
                            }else{
                                console.error(result.error);
                            }
                        },this)
                    }
                }
            }else{
                var orderUrl = this.baseUrl + "/index.php/user/api/AuthOrder/";
                var orde = {
                    uuid: config.uuid,
                    amount: config.price/100
                };
                var orderP = JSON.stringify(orde);
                var orderData = JSON.stringify({'data':'{"mod":"user","do":"api.AuthOrder","p":'+orderP+'}',"h":""});
                this.send(orderUrl,orderData,function(orderres){
                    if(orderres == 2){
                       MiniSite.authOrder(); //未成年玩家充值限值框 
                    }else{
                        // 获取APP信息
                        var url= this.baseUrl + "/index.php/pay/order/create/";
                        var param = {
                            APPID:this.app_id,
                            uuid:config.uuid,
                            pay_type:this.pay_type,
                            cp_out_order_no:config.out_order_no,
                            channel_id:this.channel_id,
                            price:config.price
                        };
                        console.info("正在创建订单... param:",this.RDPAYS);
                        var paymod = this.getParam('paymod');

                        if(this.RDPAYS){
                            var userUrl= this.baseUrl + "/index.php/user/api/getUserPosition/";
                            var uP = JSON.stringify(param);
                            var datas = JSON.stringify({'data':'{"mod":"user","do":"api.getUserPosition","p":'+uP+'}',"h":""});
                            this.send(userUrl,datas,function(result){
                                result = JSON.parse(result);
                                if(result.errCode == 0 && result.data.city){
                                    window.returnCitySN = result.data.province + result.data.city;
                                }
                                this.RDPAYSRES = getPayType(this.RDPAYS,config.price,this.RDPAYSOS);
                                if(!this.RDPAYSRES && paymod){
                                    paymod = null;
                                }
                                console.log("paymod1:",paymod);
                                if (paymod) {
                                    var judge = paymod.search("none");
                                    if (paymod.search("none") == -1) {
                                        judge = 0;
                                    } else {
                                        judge = 1;
                                    }
                                } else {
                                    var judge = 0;
                                }

                                console.log("judge:",judge);
                                if(this.pay_type == "select" && !judge){
                                    console.info("this.pay_type：",this.pay_type);
                                    MiniSite.loadPayBox(config.price,function(type){
                                        this.pay_type = type;
                                        param.pay_type = this.pay_type;
                                        console.info("订单参数:"+JSON.stringify(param));

                                        console.log(param);
                                        var signature = this.signHashHmac(param,atob(this.signkey));
                                        param.sign = signature;

                                        var p = JSON.stringify(param);
                                        var data = JSON.stringify({'data':'{"mod":"pay","do":"order.create","p":'+p+'}',"h":""});
                                        this.send(url,data,function(result){
                                            result = JSON.parse(result,true);
                                            if(result.errCode == 0){
                                                console.info("订单创建成功!order_data:");
                                                console.info(result.data);
                                                config['rd_order_no'] = result.data['order'].rd_order_no;
                                                config['state'] = result.data['order'].state;
                                                config['open_id'] = result.data['user'].username.split("gameid")[0];
                                                console.info(config);
                                                this._channelRecharge(config);
                                            }else{
                                                console.error(result.error);
                                            }
                                        },this)
                                    },this);
                                }else{
                                    console.info("订单参数:"+JSON.stringify(param));

                                    var signature = this.signHashHmac(param,atob(this.signkey));
                                    param.sign = signature;
                                    console.log(param);
                                    var p = JSON.stringify(param);
                                    var data = JSON.stringify({'data':'{"mod":"pay","do":"order.create","p":'+p+'}',"h":""});
                                    this.send(url,data,function(result){
                                        result = JSON.parse(result);
                                        if(result.errCode == 0){
                                            console.info("订单创建成功!order_data:");
                                            console.info(result);
                                            config['rd_order_no'] = result.data['order'].rd_order_no;//燃点的订单号
                                            config['open_id'] = result.data['user'].username.split("gameid")[0];//燃点用户的openid
                                            config['state'] = result.data['order'].state;//燃点订单的状态
                                            console.info(config);
                                            this._channelRecharge(config);
                                        }else{
                                            console.error(result.error);
                                        }
                                    },this)
                                }

                            },this);
                        }else{

                            console.log("paymod2:",paymod);
                            if (paymod) {
                                var judge = paymod.search("none");
                                if (paymod.search("none") == -1) {
                                    judge = 0;
                                } else {
                                    judge = 1;
                                }
                            } else {
                                var judge = 0;
                            }

                            console.log("judge:",judge);
                            if(this.pay_type == "select" && !judge){
                                console.info("this.pay_type：",this.pay_type);
                                MiniSite.loadPayBox(config.price,function(type){
                                    this.pay_type = type;
                                    param.pay_type = this.pay_type;
                                    console.info("订单参数:"+JSON.stringify(param));

                                    console.log(param);
                                    var signature = this.signHashHmac(param,atob(this.signkey));
                                    param.sign = signature;

                                    var p = JSON.stringify(param);
                                    var data = JSON.stringify({'data':'{"mod":"pay","do":"order.create","p":'+p+'}',"h":""});
                                    this.send(url,data,function(result){
                                        result = JSON.parse(result,true);
                                        if(result.errCode == 0){
                                            console.info("订单创建成功!order_data:");
                                            console.info(result.data);
                                            config['rd_order_no'] = result.data['order'].rd_order_no;
                                            config['state'] = result.data['order'].state;
                                            config['open_id'] = result.data['user'].username.split("gameid")[0];
                                            console.info(config);
                                            this._channelRecharge(config);
                                        }else{
                                            console.error(result.error);
                                        }
                                    },this)
                                },this);
                            }else{
                                console.info("订单参数:"+JSON.stringify(param));

                                var signature = this.signHashHmac(param,atob(this.signkey));
                                param.sign = signature;
                                console.log(param);
                                var p = JSON.stringify(param);
                                var data = JSON.stringify({'data':'{"mod":"pay","do":"order.create","p":'+p+'}',"h":""});
                                this.send(url,data,function(result){
                                    result = JSON.parse(result);
                                    if(result.errCode == 0){
                                        console.info("订单创建成功!order_data:");
                                        console.info(result);
                                        config['rd_order_no'] = result.data['order'].rd_order_no;//燃点的订单号
                                        config['open_id'] = result.data['user'].username.split("gameid")[0];//燃点用户的openid
                                        config['state'] = result.data['order'].state;//燃点订单的状态
                                        console.info(config);
                                        this._channelRecharge(config);
                                    }else{
                                        console.error(result.error);
                                    }
                                },this)
                            }
                        }
                    }
                },this);
            }
        },this);
    }

    /**
     * 根据channel_id分别获取对应渠道的获取用户方法
     */
    _channelUserInfo(config){
        var open_id,name,avatar;
        var that = this;
        console.log("channel_inst do getUserInfo...");
        this.channelInst.getUserInfo(function(res)  {
            open_id = res.open_id;
            name    = res.name;
            avatar  = res.avatar;
            that._tryLogin(open_id,name,avatar,res.password);
        });
    }
    /**
     * 根据channel_id分别获取对应渠道的充值方法
     */
    _channelRecharge(config){
        console.log("channel_inst do recharge...");
        var that = this;
        this.channelInst.recharge(config,function(cb)  {
            console.info(cb);//回调
            var rdCb = [];
            rdCb['id'] = config.rd_order_no;
            rdCb['out_order_no'] = config.out_order_no;
            rdCb['price'] = config.price;
            rdCb['type'] = config['state'];
            that.rechargeCallBack.call(null,rdCb);
        })
    }

    _tryLogin(open_id,name,avatar,password = ""){
        var authUrl = this.baseUrl + "/index.php/user/api/AuthEntication/";
        var paramUrl = {
            channel_id:this.channel_id,
            game_id:this.app_id
        };
        var pUrl = JSON.stringify(paramUrl);
        var dataUrl=JSON.stringify({'data':'{"mod":"user","do":"api.AuthEntication","p":'+pUrl+'}',"h":""});
        this.send(authUrl,dataUrl,function(results){
            var auth = JSON.parse(results);
        ////////////////////////////////////    
            var paramObj = {
                "account":open_id,
                "password":password.length == 0?open_id:password,
                "app_id":this.app_id,
                "channel_id":this.channel_id//新增

                // "sign":open_id
            };
             
            console.info("正在请求登陆...",paramObj);
            var signature = this.signHashHmac(paramObj,atob(this.signkey));
            paramObj.sign = signature;
            paramObj.wd_login = this.getParam('_wd') && this.getParam('_cid')?true:false;
            var url = this.baseUrl +"/index.php/user/api/login/";
            var p = JSON.stringify(paramObj);
            var data=JSON.stringify({'data':'{"mod":"user","do":"api.login","p":'+p+'}',"h":""});
            this.send(url,data,function(res){
                res = JSON.parse(res);
                if(res.errCode == 0){
                    MiniSite.wddownBox(res.data,(this.wddownBox?this.wddownBox:this.getParam('_wd')),this);
                    if(auth.data == 1){
                        if(this.isRdYk == true){
                            console.log('遊客-----------------',this.isRdYk);
                            var aurl = this.baseUrl +"index.php/user/api/AuthEnticaYK";
                            var uuid = {"uuid":res.data.uuid,"dtim":0}
                            var auth_uu = JSON.stringify(uuid);
                            var auth_uuid = JSON.stringify({'data':'{"mod":"user","do":"api.AuthEnticaYK","p":'+auth_uu+'}',"h":""});
                        }else{
                            console.log('遊客++++++++++++++++',this.isRdYk);
                            var aurl = this.baseUrl +"index.php/user/api/AuthEntica";
                            var uuid = {"uuid":res.data.uuid,"dtim":0}
                            var auth_uu = JSON.stringify(uuid);
                            var auth_uuid = JSON.stringify({'data':'{"mod":"user","do":"api.AuthEntica","p":'+auth_uu+'}',"h":""});
                        }  
                        this.send(aurl,auth_uuid,function(rest){
                            switch(rest){
                              case '0': 
                                MiniSite.authForm(this.baseUrl,res.data,this.userInfoCallBack);  //未进行实名认证
                                break;
                              case '1': 
                                console.info("登陆成功!");
                                this.userInfoCallBack.call(null,res.data); 
                                break;
                              case '2': 
                                MiniSite.authTime(); //22-8 之间 禁止未成年人上线
                                break;
                              case '3': 
                                MiniSite.authOver(); //未成年上线时间已结束
                                break;
                              case '4': 
                                console.info("登陆成功!");
                                this.userInfoCallBack.call(null,res.data);
                                var that = this;
                                var setinter = setInterval(function(){
                                    var aurls = that.baseUrl +"index.php/user/api/AuthMtime";
                                    var uuids = {"uuid":res.data.uuid}
                                    var auth_uus = JSON.stringify(uuids);
                                    var auth_uuids = JSON.stringify({'data':'{"mod":"user","do":"api.AuthMtime","p":'+auth_uus+'}',"h":""});
                                    that.send(aurls,auth_uuids,function(resauth){
                                        if(resauth == 0){
                                            if(document.getElementById('payBox')){
                                                document.getElementById('payBox').remove();
                                            }
                                            MiniSite.authOver(); 
                                            clearInterval(setinter);
                                        }else if(resauth == 2){
                                            if(document.getElementById('payBox')){
                                                document.getElementById('payBox').remove();
                                            }
                                            MiniSite.authTime();
                                            clearInterval(setinter);
                                        }
                                    },that)
                                },60000);
                                break;
                              case '5':
                                MiniSite.authYouke(); //游客模式
                                break;
                              case '6': 
                                console.info("登陆成功!");
                                this.userInfoCallBack.call(null,res.data);
                                var that = this;
                                var setinter = setInterval(function(){
                                    var aurls = that.baseUrl +"index.php/user/api/AuthMtime";
                                    var uuids = {"uuid":res.data.uuid}
                                    var auth_uus = JSON.stringify(uuids);
                                    var auth_uuids = JSON.stringify({'data':'{"mod":"user","do":"api.AuthMtime","p":'+auth_uus+'}',"h":""});
                                    that.send(aurls,auth_uuids,function(resauth){
                                        if(resauth == 0){
                                            if(document.getElementById('payBox')){
                                                document.getElementById('payBox').remove();
                                            }
                                            MiniSite.authYouke();
                                            clearInterval(setinter);
                                        }
                                    },that)
                                },60000);
                                break;
                            }
                        },this)                      
                    }else{
                        console.info("登陆成功!");
                        this.userInfoCallBack.call(null,res.data)
                    }
                }else if(res.errCode == 102){
                    console.info("账号不存在!");
                    this._tryRegister(open_id,name,avatar,paramObj.password);
                }else{
                    console.error(res.error);
                    // alert("接口异常"+res.error);
                    // window.location.reload();
                }
            },this)
        ////////////////////////////////////////////
        },this) 
    }

    _tryRegister(open_id,name,avatar,password){
        console.info("正在请求注册...");
        var paramObj = {
            "account":open_id,
            "password":password,
            "channel_id":this.channel_id,
            "nickname":name,
            "avatar":avatar?avatar:"",
            "app_id":this.app_id
        };
        console.log(atob(this.signkey));
        var signature = this.signHashHmac(paramObj,atob(this.signkey));
        paramObj.sign = signature;
        console.log(paramObj.sign);
        console.log(paramObj);
        var url = this.baseUrl +"/index.php/user/api/register/";
        var p = JSON.stringify(paramObj);
        var data=JSON.stringify({'data':'{"mod":"user","do":"api.register","p":'+p+'}',"h":""});
        this.send(url,data,function(res){
            res = JSON.parse(res);
            if(res.errCode == 0){
                console.info("注册成功!");
                this.firstLogin();
                this._tryLogin(open_id,name,avatar,password);
            }else{
                console.error(res.error);
                // alert("接口异常"+res.error);
                // window.location.reload();
            }
        },this)
    }

    signHashHmac(paramObj,localSignKey= "124858735da394eb"){
        //开始排序
        paramObj = ksort(paramObj);
        // console.log(1,paramObj);
        var str = [];
        for (var key in paramObj) {
            var value = paramObj[key];
            str.push(key+"="+value);
        }
        // console.log(2,str);
        var strData = str.join("&");
        strData += "&key="+localSignKey;
        // console.log(3,strData);
        var signature = CryptoJS.HmacSHA256(strData, localSignKey).toString();
        // console.log(4,signature);
        // signature = CryptoJS.enc.Base64.stringify(signature);
        // console.log(5,signature);
        signature = signature.toUpperCase();
        // console.log(5,signature);
        return signature;
    }

    send(url,data,cb,cbObj){
        var xmlhttp=new XMLHttpRequest();
        xmlhttp.open("POST",url,true);
        xmlhttp.send(data);
        xmlhttp.onreadystatechange=function()
        {
            if (xmlhttp.readyState==4 && xmlhttp.status==200)
            {
                cb.call(cbObj,xmlhttp.responseText);
            }
        }
    }

    onEvent(config,callback){
        try {
            if(typeof this.channelInst.onEvent === "function") {
                this.channelInst.onEvent(config,function(res)  {
                    console.info("onEvent.res..",res);
                    callback(res);
                });
            }
        } catch(e) {}
    }
}

var MiniSite = new Object();
/**
 * 判断浏览器
 */
MiniSite.Browser={
    ie:/msie/.test(window.navigator.userAgent.toLowerCase()),
    moz:/gecko/.test(window.navigator.userAgent.toLowerCase()),
    opera:/opera/.test(window.navigator.userAgent.toLowerCase()),
    safari:/safari/.test(window.navigator.userAgent.toLowerCase())
};
/**
 * JsLoader对象用来加载外部的js文件
 */
MiniSite.JsLoader={
    /**
     * 加载外部的js文件
     * @param sUrl 要加载的js的url地址
     * @fCallback js加载完成之后的处理函数
     */
    load:function(sUrl,fCallback,callbackObj){
        var _script=document.createElement('script');
        _script.setAttribute('charset','utf-8');
        _script.setAttribute('type','text/javascript');
        _script.setAttribute('src',sUrl);
        document.getElementsByTagName('head')[0].appendChild(_script);
        if(MiniSite.Browser.ie){
            _script.onreadystatechange=function(){
                if(this.readyState=='loaded'||this.readyStaate=='complete'){
                    //fCallback();
                    if(fCallback!=undefined){
                        fCallback.call(callbackObj);
                    }
                }
            };
        }else if(MiniSite.Browser.moz){
            _script.onload=function(){
                //fCallback();
                if(fCallback!=undefined){
                    fCallback.call(callbackObj);
                }
            };
        }else{
            //fCallback();
            if(fCallback!=undefined){
                fCallback.call(callbackObj);
            }
        }
    }
};

/**
 * 动态加载CSS
 * @param {string} url 样式地址
 */
MiniSite.CssLoader = {
    load:function(url){
        var head = document.getElementsByTagName('head')[0];
        var link = document.createElement('link');
        link.type='text/css';
        link.rel = 'stylesheet';
        link.href = url;
        head.appendChild(link);
    }
}

MiniSite.loadPayBox = function(price,callback,callbackObj) {
    console.info("MiniSite.loadPayBox...",price);
    var e = $("#payBox")
    console.log(e);
    if (!$("#payBox").length) {
        var f = '<li data-type="alipay" class="flex"><i class="icon-alipay"></i><span class="flex-list">支付宝支付(推荐)</span></li><li data-type="weixin" class="flex"><i class="icon-wxpay"></i><span class="flex-list">微信支付</span></li>';
        var g = '<div id="payBox" class="pay-box" style="z-index:9999;">';
        g += '<div class="r5">';
        g += '<div class="pay-head">选择支付方式<i class="icon-cancel" onclick="MiniSite.closePayBox(true)"></i></div>';
        g += '<div class="pay-info">';
        g += '<p class="paybox-tip">您需支付</p>';
        g += '<p class="paybox-price">¥<span id="price">' + (price/100).toFixed(2) + "</span></p>";
        g += "</div>";
        g += '<div class="pay-mode">';
        g += '<ul id="pay-list">' + f + "</ul>";
        g += "</div>";
        g += "</div></div>";
        $("body").append(g)
        // (price/10).toFixed(1)
        console.info("MiniSite.end");
    }

    $("#pay-list li").off().click(function(result) {
        var dataType = $(this).data("type")
        MiniSite.closePayBox(false)
        if(callback)callback.call(callbackObj,dataType);
    })
}

MiniSite.authTime = function() {
    var e = $("#payBox")
    console.log(e);
    if (!$("#payBox").length) {
        var g = '<div id="payBox" class="pay-box" style="z-index:9999;">';
        g += '<div class="r5">';
        g += '<div class="pay-head"><li style="font-size:2rem;font-weight: bold; color:red">温馨提示</li></div>';
        g += '<div class="pay-info" style="text-align:left;">';
        g += '<p class="paybox-auth" style="margin:1rem;font-size:1.5rem;padding: 4rem;">未成年玩家，于22时至次日8时，禁止登陆！！</p>';
        g += "</div>";
        g += "</div></div>";
        $("body").append(g)
    }
}

MiniSite.authOver = function() {
    var e = $("#payBox")
    console.log(e);
    if (!$("#payBox").length) {
        var g = '<div id="payBox" class="pay-box" style="z-index:9999;">';
        g += '<div class="r5">';
        g += '<div class="pay-head"><li style="font-size:2rem;font-weight: bold; color:red">温馨提示</li></div>';
        g += '<div class="pay-info" style="text-align:left;">';
        g += '<p class="paybox-auth" style="margin:1rem; font-size:1.5rem">未成年玩家，节假日游戏累计游戏时间不得超过3小时；其他时间游戏累计时间不得超过1.5小时。</p>';
        g += "</div>";
        g += "</div></div>";
        $("body").append(g)
        console.info("MiniSite.end");
    }
}

MiniSite.authYouke = function() {
    var e = $("#payBox")
    console.log(e);
    if (!$("#payBox").length) {
        var g = '<div id="payBox" class="pay-box" style="z-index:9999;">';
        g += '<div class="r5">';
        g += '<div class="pay-head"><li style="font-size:2rem;font-weight: bold; color:red">温馨提示</li></div>';
        g += '<div class="pay-info" style="text-align:left;">';
        g += '<p class="paybox-auth" style="margin:1rem;font-size:1.5rem;">1. 游客玩家游戏累计游戏时间不得超过1小时；</p>';
        g += '<p class="paybox-auth" style="margin:1rem;font-size:1.5rem;">2. 游客玩家游戏累计游戏时间超过1小时，15日之后可继续登录。</p>';
        g += "</div>";
        g += "</div></div>";
        $("body").append(g)
    }
}

MiniSite.authOrder = function() {
    var e = $("#payBox")
    console.log(e);
    if (!$("#payBox").length) {
        var g = '<div id="payBox" class="pay-box" style="z-index:9999;">';
        g += '<div class="r5">';
        g += '<div class="pay-head"><li style="font-size:2rem;font-weight: bold; color:red">温馨提示</li></div>';
        g += '<div class="pay-info" style="text-align:left;">';
        g += '<p class="paybox-auth" style="margin:1rem; font-size:1.5rem">1. 0-8岁未成年玩家，暂无充值权限；</p>';
        g += '<p class="paybox-auth" style="margin:1rem; font-size:1.5rem">2. 8-16岁未成年玩家单笔充值不得超过50元，本月累计充值不得超过200元；</p>';
        g += '<p class="paybox-auth" style="margin:1rem; font-size:1.5rem">3. 16-28岁未成年玩家单笔充值不得超过100元，本月累计充值不得超过400元。</p>';
        g += "</div>";
        g += "</div></div>";
        $("body").append(g)
        console.info("MiniSite.end");
    }
}

MiniSite.authForm = function(url,data,userInfoCallBack) {
    var e = $("#payBox")
    console.log(e);
    if (!$("#payBox").length) {
        var f = '<div class="basic-grey"><form id="form" action="" method="post" ><label><span>姓名 :</span><input id="name" type="text" name="name" placeholder="请输入真实姓名"/></label><label><span>身份证 :</span><input id="id_cade" type="text" name="id_cade" placeholder="身份证号" /></label><label><span>手机号 :</span><input id="phone" type="text" name="phone" placeholder="手机号" /></label><input type="hidden" name="uuid" value="'+data.uuid+'"><label><input type="button" class="button" value="提交" /></label></form></div>';
        var g = '<div id="payBox" class="pay-box" style="z-index:9999;">';
        g += '<div class="rr">';
        g += '<div class="pay-head">实名认证</div>';
        g += '<div class="pay-info" style="text-align:left;">';
        g +=  f ;
        g += "</div></div>";
        $("body").append(g)
    }
    $(".button").click(function(){
        $.ajax({
            url: url+'/index.php/user/api/authform/',
            type: "post",
            data: $('#form').serialize(),
            dataType: "json",
            success: function (res) {
                if(res == 2){
                    $("#payBox").remove();
                    MiniSite.authTime();
                }else if(res == 0){
                    alert('姓名和身份证号不一致!!!'); 
                }else{
                    $("#payBox").remove();
                    console.info("登陆成功!");
                    userInfoCallBack.call(null,data); 
                }
            }
        })
    })
}

MiniSite.closePayBox = function(res){
    $(".pay-box").remove();
    if(res == true && window.rechargeSdk.rechargeCallBack){
        window.rechargeSdk.rechargeCallBack(false);
    }
}

MiniSite.wddownBox = function(userInfo,tags,that){
    if(tags){
        MiniSite.CssLoader.load(that.baseUrl+"sdk/wddown/rd_qikoo.css");
        MiniSite.JsLoader.load(that.baseUrl+"sdk/wddown/rd_qikoo.js",function(){
            window.rd_qikoo.init(that,userInfo,tags,that.getParam("_cid"));
        },that);
    }
}

function wdConfigs(config,obj){
    if(obj){
        for(var p in obj){
            if(config[p] && obj[p]){
                config[p] = obj[p];
            }
        }
    }
    return config;
}

function ksort(inputArr, sort_flags = "SORT_REGULAR") {
    var tmp_arr = {},
        keys = [],
        sorter, i, k, that = this,
        strictForIn = false,
        populateArr = {};

    switch (sort_flags) {
        case 'SORT_STRING':
            // compare items as strings
            sorter = function (a, b) {
                return that.strnatcmp(a, b);
            };
            break;
        case 'SORT_LOCALE_STRING':
            // compare items as strings, original by the current locale (set with  i18n_loc_set_default() as of PHP6)
            var loc = this.i18n_loc_get_default();
            sorter = this.php_js.i18nLocales[loc].sorting;
            break;
        case 'SORT_NUMERIC':
            // compare items numerically
            sorter = function (a, b) {
                return ((a + 0) - (b + 0));
            };
            break;
        // case 'SORT_REGULAR': // compare items normally (don't change types)
        default:
            sorter = function (a, b) {
                var aFloat = parseFloat(a),
                    bFloat = parseFloat(b),
                    aNumeric = aFloat + '' === a,
                    bNumeric = bFloat + '' === b;
                if (aNumeric && bNumeric) {
                    return aFloat > bFloat ? 1 : aFloat < bFloat ? -1 : 0;
                } else if (aNumeric && !bNumeric) {
                    return 1;
                } else if (!aNumeric && bNumeric) {
                    return -1;
                }
                return a > b ? 1 : a < b ? -1 : 0;
            };
            break;
    }

    // Make a list of key names
    for (k in inputArr) {
        if (inputArr.hasOwnProperty(k)) {
            keys.push(k);
        }
    }
    keys.sort(sorter);

    // BEGIN REDUNDANT
    this.php_js = this.php_js || {};
    this.php_js.ini = this.php_js.ini || {};
    // END REDUNDANT
    strictForIn = this.php_js.ini['phpjs.strictForIn'] && this.php_js.ini['phpjs.strictForIn'].local_value && this.php_js
        .ini['phpjs.strictForIn'].local_value !== 'off';
    populateArr = strictForIn ? inputArr : populateArr;

    // Rebuild array with sorted key names
    for (i = 0; i < keys.length; i++) {
        k = keys[i];
        tmp_arr[k] = inputArr[k];
        if (strictForIn) {
            delete inputArr[k];
        }
    }
    for (i in tmp_arr) {
        if (tmp_arr.hasOwnProperty(i)) {
            populateArr[i] = tmp_arr[i];
        }
    }

    return strictForIn || populateArr;
}


function setCookie(name,value,time)
{
    var strsec = getsec(time);
    var exp = new Date();
    exp.setTime(exp.getTime() + strsec*1);
    document.cookie = name + "="+ escape (value) + ";expires=" + exp.toGMTString();
}


//读取cookies
function getCookie(name)
{
    var arr,reg=new RegExp("(^| )"+name+"=([^;]*)(;|$)");

    if(arr=document.cookie.match(reg))

        return unescape(arr[2]);
    else
        return null;
}

//删除cookies
function delCookie(name)
{
    var exp = new Date();
    exp.setTime(exp.getTime() - 1);
    var cval=getCookie(name);
    if(cval!=null)
        document.cookie= name + "="+cval+";expires="+exp.toGMTString();
}
//使用示例
// setCookie("name","hayden");
// getCookie("name");

//如果需要设定自定义过期时间
//那么把上面的setCookie　函数换成下面两个函数就ok;

function getsec(str)
{
    var str1=str.substring(1,str.length)*1;
    var str2=str.substring(0,1);
    if (str2=="s")
    {
        return str1*1000;
    }
    else if (str2=="h")
    {
        return str1*60*60*1000;
    }
    else if (str2=="d")
    {
        return str1*24*60*60*1000;
    }
}

//生成从minNum到maxNum的随机数
function randomNum(minNum,maxNum){
    switch(arguments.length){
        case 1:
            return parseInt(Math.random()*minNum+1,10);
            break;
        case 2:
            return parseInt(Math.random()*(maxNum-minNum+1)+minNum,10);
            break;
        default:
            return 0;
            break;
    }
}
